%global	eclipse_dropins	%{_datadir}/eclipse/dropins

%global dali_tag			201309042005
%global dali_dir			webtools.dali-%{dali_tag}

# Get shortcommit for this from map file, then figure out the full commit sha
%global eclipselink_commit	981335c676d747cae63a316924901c91ad9d3981
%global eclipselink_dir		eclipselink.runtime-%{eclipselink_commit}

Name:		eclipse-wtp-jpa
Version:	3.5.1
Release:	1%{?dist}
Summary:	Eclipse tools for definition of (O/R) mappings for JPA entities

Group:		Development/Tools
License:	EPL
URL:		http://www.eclipse.org/webtools/dali/

Source0:	http://git.eclipse.org/c/dali/webtools.dali.git/snapshot/%{dali_dir}.tar.bz2
Source1:	http://git.eclipse.org/c/eclipselink/eclipselink.runtime.git/snapshot/%{eclipselink_dir}.tar.bz2

Patch0:		org.eclipse.jpt.common.utility-explicit-cast.patch
Patch1:		org.eclipse.jpt.jpa.feature-remove-version-checks.patch
Patch3:		%{name}-jpa_sdk_feature.patch

BuildArch:	noarch

BuildRequires:	apache-commons-logging >= 1.1.2
BuildRequires:	apache-commons-discovery >= 0.5
BuildRequires:	apache-commons-collections >= 3.2.1
BuildRequires:	apache-commons-lang >= 2.6
BuildRequires:	eclipse-dtp >= 1.11.0
BuildRequires:	eclipse-emf >= 2.9.1
BuildRequires:	eclipse-emf-core >= 2.9.1
BuildRequires:	eclipse-emf-xsd >= 2.9.1
BuildRequires:	eclipse-gef >= 3.9.0
BuildRequires:	eclipse-jdt >= 4.3.1
BuildRequires:	eclipse-pde >= 4.3.1
BuildRequires:	eclipse-platform >= 4.3.1
BuildRequires:	eclipse-rcp >= 4.3.1
BuildRequires:	eclipse-swt >= 4.3.1
BuildRequires:	eclipse-wtp-common >= 3.5.1
BuildRequires:	eclipse-wtp-jeetools >= 3.5.1
BuildRequires:	eclipse-wtp-servertools >= 3.5.1
BuildRequires:	eclipse-wtp-sourceediting >= 3.5.1
BuildRequires:	hibernate-jpa-2.0-api >= 1.0.1
BuildRequires:	icu4j-eclipse >= 50.1.1
BuildRequires:	jdom >= 1.1.3
BuildRequires:	velocity >= 1.7

Requires:	apache-commons-logging >= 1.1.2
Requires:	apache-commons-discovery >= 0.5
Requires:	apache-commons-collections >= 3.2.1
Requires:	apache-commons-lang >= 2.6
Requires:	eclipse-dtp >= 1.11.0
Requires:	eclipse-emf >= 2.9.1
Requires:	eclipse-emf-core >= 2.9.1
Requires:	eclipse-emf-xsd >= 2.9.1
Requires:	eclipse-gef >= 3.9.0
Requires:	eclipse-jdt >= 4.3.1
Requires:	eclipse-pde >= 4.3.1
Requires:	eclipse-platform >= 4.3.1
Requires:	eclipse-rcp >= 4.3.1
Requires:	eclipse-swt >= 4.3.1
Requires:	eclipse-wtp-common >= 3.5.1
Requires:	eclipse-wtp-jeetools >= 3.5.1
Requires:	eclipse-wtp-servertools >= 3.5.1
Requires:	eclipse-wtp-sourceediting >= 3.5.1
Requires:	hibernate-jpa-2.0-api >= 1.0.1
Requires:	icu4j-eclipse >= 50.1.1
Requires:	jdom >= 1.1.3
Requires:	velocity >= 1.7


%description
The Dali Java Persistence Tools Project provides extensible frameworks and
tools for the definition and editing of Object-Relational (O/R) mappings for
Java Persistence API (JPA) entities. JPA mapping support focuses on minimizing
the complexity of mapping by providing entity generation wizards, design-time
validation, and a rich UI for entity and persistence unit configuration.

%package	sdk
Summary:	SDK for Eclipse Webtools JPA
Group:		System Environment/Libraries
Requires:	java-javadoc
Requires:	eclipse-pde
Requires:	%{name} = %{version}-%{release}

%description sdk
Documentation and source for the Eclipse Webtools 'Dali' Java Persistence Tools.


%prep
%setup -q -n %{dali_dir}

tar xfj %{SOURCE1}
pushd %{eclipselink_dir}
cp -r jpa/org.eclipse.persistence.jpa.jpql/ ../
popd
rm -r %{eclipselink_dir}

find . -type f -name *.jar -exec rm -f {} \;
find . -type f -name *.class -exec rm -f {} \;

pushd common/plugins
%patch0
popd

pushd jpa/features
%patch1 -b .orig
%patch3
popd

#Orbit links
rm -rf orbit
mkdir orbit
pushd orbit
%{__ln_s} %{_javadir}/jdom.jar
%{__ln_s} %{_javadir}/velocity.jar
%{__ln_s} %{_javadir}/hibernate-jpa-2.0-api.jar
%{__ln_s} %{_javadir}/apache-commons-collections.jar
%{__ln_s} %{_javadir}/apache-commons-lang.jar
popd

# Remove problematic license feature
find -name feature.xml -type f \
	-exec sed -i -e 's/license-feature="org.eclipse.license"//g' {} \;


%build
# TODO: Stuff not being built yet:
# None of jpa_diagram_editor (needs emf-transaction & emf validation & graphiti
# Not all of the eclipselink features

%{_bindir}/eclipse-pdebuild -f org.eclipse.jpt.common.feature \
	-d "eclipse-wtp-common emf wtp-sourceediting wtp-jeetools\
	   org.eclipse.jst.server_ui.feature wtp-webservices xsd gef" \
	-o `pwd`/orbit

%{_bindir}/eclipse-pdebuild -f org.eclipse.jpt.common.eclipselink.feature \
	-d "eclipse-wtp-common emf wtp-sourceediting wtp-jeetools\
	   org.eclipse.jst.server_ui.feature wtp-webservices xsd gef" \
	-o `pwd`/orbit

%{_bindir}/eclipse-pdebuild -f org.eclipse.jpt.jpa.feature \
	-d "gef emf wtp-webservices wtp-jeetools dtp-enablement dtp-modelbase \
	   eclipse-wtp-common dtp-connectivity dtp-sqldevtools \
	   org.eclipse.jst.server_ui.feature wtp-sourceediting wtp-jeetools" \
	-o `pwd`/orbit

%{_bindir}/eclipse-pdebuild -f org.eclipse.jpt.jaxb.feature \
	-d "gef emf wtp-webservices wtp-jeetools dtp-enablement dtp-modelbase \
	   eclipse-wtp-common dtp-connectivity dtp-sqldevtools \
	   org.eclipse.jst.server_ui.feature wtp-sourceediting xsd" \
	-o `pwd`/orbit

# build sdk features
%{_bindir}/eclipse-pdebuild -f org.eclipse.jpt.jpa_sdk.feature
%{_bindir}/eclipse-pdebuild -f org.eclipse.jpt.jaxb_sdk.feature
%{_bindir}/eclipse-pdebuild -f org.eclipse.jpt.common_sdk.feature


%install
install -d -m 755 %{buildroot}%{eclipse_dropins}/wtp-jpa
install -d -m 755 %{buildroot}%{eclipse_dropins}/wtp-jpa-sdk

%{__unzip} -q -d %{buildroot}%{eclipse_dropins}/wtp-jpa \
	   build/rpmBuild/org.eclipse.jpt.common.feature.zip
%{__unzip} -q -d %{buildroot}%{eclipse_dropins}/wtp-jpa \
	   build/rpmBuild/org.eclipse.jpt.common.eclipselink.feature.zip
%{__unzip} -q -d %{buildroot}%{eclipse_dropins}/wtp-jpa \
	   build/rpmBuild/org.eclipse.jpt.jpa.feature.zip
%{__unzip} -q -d %{buildroot}%{eclipse_dropins}/wtp-jpa \
	   build/rpmBuild/org.eclipse.jpt.jaxb.feature.zip

%{__unzip} -q -d %{buildroot}%{eclipse_dropins}/wtp-jpa-sdk \
	   build/rpmBuild/org.eclipse.jpt.jpa_sdk.feature.zip
%{__unzip} -q -d %{buildroot}%{eclipse_dropins}/wtp-jpa-sdk \
	   build/rpmBuild/org.eclipse.jpt.jaxb_sdk.feature.zip
%{__unzip} -q -d %{buildroot}%{eclipse_dropins}/wtp-jpa-sdk \
	   build/rpmBuild/org.eclipse.jpt.common_sdk.feature.zip

#Recreate symlinks & remove duplicate jars
pushd %{buildroot}%{eclipse_dropins}/wtp-jpa/eclipse/plugins

rm -f org.jdom_*.jar
rm -f org.apache.velocity_*.jar
rm -f org.apache.commons.lang_*.jar
rm -f org.apache.commons.collections_*.jar

%{__ln_s} %{_javadir}/jdom.jar
%{__ln_s} %{_javadir}/velocity.jar
%{__ln_s} %{_javadir}/apache-commons-lang.jar
%{__ln_s} %{_javadir}/apache-commons-collections.jar
popd

%files
%{eclipse_dropins}/wtp-jpa
%doc jpa/features/org.eclipse.jpt.jpa.eclipselink.feature/sourceTemplatePlugin/license.html
%doc common/plugins/org.eclipse.jpt.common.core/about.html

%files sdk
%{eclipse_dropins}/wtp-jpa-sdk

%changelog
* Sat Oct 12 2013 Gerard Ryan <galileo@fedoraproject.org> - 3.5.1-1
- Update to latest upstream version 3.5.1

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.5.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Mon Jun 24 2013 Gerard Ryan <galileo@fedoraproject.org> - 3.5.0-1
- Update to latest upstream version 3.5.0

* Tue May 21 2013 Gerard Ryan <galileo@fedoraproject.org> 3.5.0-0.1
- Start building from upstream master branches in anticipation for 3.5.0

* Thu May 09 2013 Gerard Ryan <galileo@fedoraproject.org> 3.4.2-1
- Update to latest upstream version
- Get proper sources from Git
- Remove org.eclipse.license stuff
- Update min dependency versions based on download.eclipse.org/webtools/downloads/drops/R3.4.2/R-3.4.2-20130208151217/?d

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jul 13 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-1
- Update to R3.4.0 Juno stable release

* Thu Jul 5 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.2.20120619cvs
- Add comment on how to create tarball
- Add add apache-commons-collections and apache-commons-lang to BR/R

* Tue Jun 19 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.1.20120619cvs
- Initial Fedora package
